#
#  Copyright 1999 Illinois Institute of Technology
#
#  See the file "LICENSE" for information on usage and redistribution
#  of this file, and for a DISCLAIMER OF ALL WARRANTIES.
#

proc create_periodic_table_window { window use_toplevel \
		state_cmd handler_cmd use_menubutton customize_cmd } {

	if { $use_toplevel == 0 } {
		set window $window
	} else {
		toplevel $window

		wm title $window "Periodic Table of the Elements"
	}

	set grid $window.main_grid

	frame $grid
	pack $grid -side top

	add_element $grid  H   1  0  0  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  He  2  0 17  $state_cmd $handler_cmd $use_menubutton

	add_element $grid  Li  3  1  0  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Be  4  1  1  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  B   5  1 12  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  C   6  1 13  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  N   7  1 14  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  O   8  1 15  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  F   9  1 16  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ne 10  1 17  $state_cmd $handler_cmd $use_menubutton

	add_element $grid  Na 11  2  0  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Mg 12  2  1  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Al 13  2 12  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Si 14  2 13  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  P  15  2 14  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  S  16  2 15  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Cl 17  2 16  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ar 18  2 17  $state_cmd $handler_cmd $use_menubutton

	add_element $grid  K  19  3  0  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ca 20  3  1  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Sc 21  3  2  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ti 22  3  3  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  V  23  3  4  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Cr 24  3  5  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Mn 25  3  6  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Fe 26  3  7  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Co 27  3  8  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ni 28  3  9  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Cu 29  3 10  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Zn 30  3 11  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ga 31  3 12  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ge 32  3 13  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  As 33  3 14  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Se 34  3 15  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Br 35  3 16  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Kr 36  3 17  $state_cmd $handler_cmd $use_menubutton

	add_element $grid  Rb 37  4  0  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Sr 38  4  1  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Y  39  4  2  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Zr 40  4  3  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Nb 41  4  4  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Mo 42  4  5  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Tc 43  4  6  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ru 44  4  7  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Rh 45  4  8  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Pd 46  4  9  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ag 47  4 10  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Cd 48  4 11  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  In 49  4 12  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Sn 50  4 13  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Sb 51  4 14  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Te 52  4 15  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  I  53  4 16  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Xe 54  4 17  $state_cmd $handler_cmd $use_menubutton

	add_element $grid  Cs 55  5  0  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ba 56  5  1  $state_cmd $handler_cmd $use_menubutton

	add_element $grid  Hf 72  5  3  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ta 73  5  4  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  W  74  5  5  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Re 75  5  6  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Os 76  5  7  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ir 77  5  8  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Pt 78  5  9  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Au 79  5 10  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Hg 80  5 11  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Tl 81  5 12  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Pb 82  5 13  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Bi 83  5 14  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Po 84  5 15  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  At 85  5 16  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Rn 86  5 17  $state_cmd $handler_cmd $use_menubutton

	add_element $grid  Fr 87  6  0  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ra 88  6  1  $state_cmd $handler_cmd $use_menubutton

	add_element $grid  Db 104 6  3  $state_cmd $handler_cmd $use_menubutton
	add_element $grid 105 105 6  4  $state_cmd $handler_cmd $use_menubutton
	add_element $grid 106 106 6  5  $state_cmd $handler_cmd $use_menubutton
	add_element $grid 107 107 6  6  $state_cmd $handler_cmd $use_menubutton
	add_element $grid 108 108 6  7  $state_cmd $handler_cmd $use_menubutton
	add_element $grid 109 109 6  8  $state_cmd $handler_cmd $use_menubutton

	#  Insert a spacer

	label $grid.spacer -text "  "
	grid $grid.spacer -row 7 -column 0

	#  Now do the Lanthanides and Actinides

	add_element $grid  La 57  8  2  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ce 58  8  3  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Pr 59  8  4  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Nd 60  8  5  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Pm 61  8  6  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Sm 62  8  7  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Eu 63  8  8  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Gd 64  8  9  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Tb 65  8 10  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Dy 66  8 11  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Ho 67  8 12  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Er 68  8 13  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Tm 69  8 14  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Yb 70  8 15  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Lu 71  8 16  $state_cmd $handler_cmd $use_menubutton

	add_element $grid  Ac 89  9  2  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Th 90  9  3  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Pa 91  9  4  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  U  92  9  5  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Np 93  9  6  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Pu 94  9  7  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Am 95  9  8  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Cm 96  9  9  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Bk 97  9 10  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Cf 98  9 11  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Es 99  9 12  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Fm 100 9 13  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Md 101 9 14  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  No 102 9 15  $state_cmd $handler_cmd $use_menubutton
	add_element $grid  Lr 103 9 16  $state_cmd $handler_cmd $use_menubutton

	if { $use_toplevel != 0 } {
		frame $window.sep1
		pack $window.sep1 -side top -pady 5

		button $window.close -text Close -command \
					[ code destroy $window ]

		pack $window.close -side top -pady 5
	}
	if { [ string length $customize_cmd ] > 0 } {
		$customize_cmd $window
	}
}

proc add_element { grid element_name atomic_number row column \
				state_cmd handler_cmd use_menubutton } {

	set frame ${grid}.element${element_name}

	frame $frame
	grid $frame -row $row -column $column -sticky nesw

	if { $use_menubutton } {
		menubutton $frame.button -text $element_name \
			-width 3 -relief raised \
			-state [ $state_cmd $element_name ]

		set menu $frame.button.menu

		menu $menu -tearoff 0 -postcommand [ code $handler_cmd $frame ]

		$frame.button configure -menu $menu
	} else {
		button $frame.button -width 2 -text $element_name \
			-state [ $state_cmd $element_name ] \
			-command [ code $handler_cmd $frame ]
	}

	pack $frame.button -expand yes -fill both

	# The following label is used to store the atomic number and
	# is not meant to be visible, so don't pack or grid it.

	label $frame.number -text $atomic_number
}

